clear all
clc

global R1 J_Ric delta ex fval

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ex = 0 gir full matrise med tilbakekopling fra x_k
% ex = 1 gir multivariabel PI-reg med tilbakekopling fra y_k
% ex = 2 gir PI-reg med parring og tilbakekopling fra y_k
% ex = 3 gir PI-reg med parring og tilbakekopling fra y_k
ex = 0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Ac = [0 1 0; 0 0 1; 2 -1 -2];  
Bc = [-1 1; 1 0; 0 1];
Dc = [0 5 -1; -1 -1 0];
Ec = zeros(2,2);

[nx, dummy] = size(Ac);
[dummy, nu] = size(Bc);
[ny, dummy] = size(Dc);

dt = 0.05;

A = expm(Ac*dt);
B = inv(Ac)*(expm(Ac*dt)-eye(nx))*Bc;
D = Dc;
E = Ec;

At = [A zeros(nx,ny); D eye(ny,ny)];
Bt = [B; zeros(ny,nu)];
Dt = [D zeros(ny,ny)];
Et = E;

Q = eye(2);
Qz = eye(2);
P = eye(2);

if ex == 0
    flag = 1; 
    F = ones(2,5); 
    F1 = 0;
    F2 = 0;
elseif ex == 1
    flag = 0;
    F = 0;
    F1 = ones(2,2);
    F2 = ones(2,2);
elseif ex == 2
    flag = 0;    
    F = 0;
    F1 = [1 0; 0 1];
    F2 = [1 0; 0 1];
elseif ex ==3
    flag = 0;
    F = 0;
    F1 = [0 1; 1 0];
    F2 = [0 1; 1 0];
end

[G1,G2,G_sub,G_opt] = suboptimal_int(F,F1,F2,At,Bt,Dt,Et,Q,Qz,P,flag,nx,nu,ny)

if flag == 0
    egenverdier = abs(eig(At+Bt*[G1*D G2]))
elseif flag == 1
    egenverdier = abs(eig(At+Bt*G_opt))
end

J_G = trace(R1)
gamma = trace(R1)/J_Ric
