function [G1,G2,G_sub,G_opt] = suboptimal_int(F,F1,F2,A,B,D,E,Q,Qz,P,flag,nx,nu,ny)

global R1 J_Ric fval Ric1 delta ex

if E == 0
    Qt = [D(1:ny,1:nx)'*Q*D(1:ny,1:nx) zeros(nx,ny); zeros(ny,nx) Qz];
    Pt = P;
    Nt = zeros(size(B));
else
    Qt = [D(1:ny,1:nx)'*Q*D(1:ny,1:nx) zeros(nx,ny); zeros(ny,nx) Qz];
    Pt = E'*Q*E+P
    Nt = D'*Q*E
end

[G_opt,Ric1] = dlqr(A,B,Qt,Pt,Nt);
G_opt = -G_opt;
J_Ric = trace(Ric1);


if flag == 0
    if ex == 1
        theta = zeros(8,1);
        x0 = zeros(8,1);
    else 
        theta = zeros(4,1);
        x0 = zeros(4,1);
    end
elseif flag == 1
    theta = css(G_opt,F);
    x0 = theta;
end

if flag == 0
    [G1, G2] = invcss_int(theta,F1,F2);
    D_ = D(1:ny,1:nx);
    G = [G1*D_ G2] ;
    At = (A+B*G);
    xk = max(abs(eig(At)));
    
    if xk >= 1
        delta = 0.9;
    elseif xk < 1
        delta = 1; 
    end
end


Options = optimset('MaxFunEvals',20000,'MaxIter',20000);

while delta ~= 1
    [theta_asterix, fval, Exitflag, Output] = fminsearch(@theta_fun,x0,Options,F,F1,F2,A,B,D,E,Q,Qz,P,flag,nx,nu,ny);
    if flag == 0
        [G1, G2] = invcss_int(theta_asterix,F1,F2);
        D_ = D(1:ny,1:nx);
        G = [G1*D_ G2];
        At = (A+B*G);
        xk = max(abs(eig(At)));
        if xk >= 1
            if ex == 3
            delta = delta + 0.001;
        else
            delta = delta + 0.05;        
        end
        elseif xk < 1
            delta = 1;
        end
    end
    x0 = theta_asterix;
end
[theta_asterix, fval, Exitflag, Output] = fminsearch(@theta_fun,x0,Options,F,F1,F2,A,B,D,E,Q,Qz,P,flag,nx,nu,ny);

if flag == 0
    [G1, G2] = invcss_int(theta_asterix,F1,F2);
    G_sub = 0;
elseif flag == 1
    G1 = 0;
    G2 = 0;
    G_sub = invcss(theta_asterix,F);
end


