clear all
clc

global R J_Ric delta ex fval

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ex = 0 gir full matrise med tilbakekopling fra x_k
% ex = 1 gir multivariabel PI-reg med tilbakekopling fra y_k
% ex = 2 gir PI-reg med parring og tilbakekopling fra y_k
% ex = 3 gir PI-reg med parring og tilbakekopling fra y_k
ex = 0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Ac = [0 1 0; 0 0 1; 2 -1 -2];  
Bc = [-1 1; 1 0; 0 1];
Dc = [0 5 -1; -1 -1 0];
Ec = zeros(2,2);

[nx, dummy] = size(Ac);
[dummy, nu] = size(Bc);
[ny, dummy] = size(Dc);

dt = 0.05;

A = expm(Ac*dt);
B = inv(Ac)*(expm(Ac*dt)-eye(nx))*Bc;
D = Dc;
E = Ec;

flag = 0;

Q = D'*D;
P = eye(2);



if ex == 0
    flag = 1; 
    F = ones(2,3); 
elseif ex == 1
    flag = 0;
    F = ones(2,2);
elseif ex == 2
    flag = 0;    
    F = [1 0; 0 1];
elseif ex ==3
    flag = 0;
    F = [0 1; 1 0];
end



[G_sub,G_opt] = suboptimal(F,A,B,D,E,Q,P,flag)

if flag == 0
    egenverdier = abs(eig(A+B*(G_sub*D)))
elseif flag == 1
    egenverdier = abs(eig(A+B*G_sub))
end
J_G = fval
gamma = fval/J_Ric