function [G_sub,G_opt] = suboptimal(F,A,B,D,E,Q,P,flag)

global R fval J_Ric delta ex
if E == 0
    Qt = Q;
    Pt = P;
    Nt = zeros(size(B));
else
    Qt = D'*Q*D;
    Pt = E'*Q*E+P;
    Nt = D'*Q*E;
end

[G_opt,Ric] = dlqr(A,B,Qt,Pt,Nt);
G_opt = -G_opt;
J_Ric = trace(Ric);

theta = css(G_opt,F);
if flag == 0
    x0 = theta*0;
elseif flag == 1
    x0 = theta;
end
Options = optimset('MaxFunEvals',5000,'MaxIter',5000);

if flag == 0
    Gy = invcss(theta,F);
    G = Gy*D;
    At = (A+B*G);
    xk = max(abs(eig(At)));
    
    if xk >= 1
        delta = 0.7;
    elseif xk < 1
        delta = 1; 
    end
end

while delta ~= 1
    [theta_asterix, fval, Exitflag, Output] = fminsearch(@theta_fun_old,x0,Options,F,A,B,D,E,Q,P,flag);
    if flag == 0
    Gy = invcss(theta_asterix,F);
    G = Gy*D;
    At = (A+B*G);
    xk = max(abs(eig(At)));
    
    if xk >= 1
        if ex == 3
            delta = delta + 0.01;
        else
            delta = delta + 0.05;
        end
        elseif xk < 1
            delta = 1; 
        end
end
    x0 = theta_asterix;
end

[theta_asterix, fval, Exitflag, Output] = fminsearch(@theta_fun_old,x0,Options,F,A,B,D,E,Q,P,flag);

G_sub = invcss(theta_asterix,F);
